diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index d436bb5..7821d2c 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,15 @@
 2019-12-11  Tom Tromey  <tom@tromey.com>
 
+	* tui/tui-wingeneral.c (tui_gen_win_info::make_window): Update.
+	* tui/tui-win.c (tui_adjust_win_heights, tui_resize_all): Update.
+	* tui/tui-layout.c (tui_gen_win_info::resize): Update.
+	* tui/tui-data.h (struct tui_point): Remove.
+	(struct tui_gen_win_info) <origin>: Remove.
+	<x, y>: New fields.
+	* tui/tui-command.c (tui_cmd_window::resize): Update.
+
+2019-12-11  Tom Tromey  <tom@tromey.com>
+
 	* tui/tui-stack.h (struct tui_locator_window) <min_height>:
 	Implement.
 	* tui/tui-regs.h (struct tui_data_item_window) <min_height>:
diff --git a/gdb/tui/tui-command.c b/gdb/tui/tui-command.c
index 9a43297..e4c3a1b 100644
--- a/gdb/tui/tui-command.c
+++ b/gdb/tui/tui-command.c
@@ -50,8 +50,8 @@
     }
   else
     viewport_height = 1;
-  origin.x = origin_x;
-  origin.y = origin_y;
+  x = origin_x;
+  y = origin_y;
 
   if (handle == nullptr)
     make_window ();
@@ -66,7 +66,7 @@
 #ifdef HAVE_WRESIZE
       wresize (handle.get (), height, width);
 #endif
-      mvwin (handle.get (), origin.y, origin.x);
+      mvwin (handle.get (), y, x);
       wmove (handle.get (), 0, 0);
     }
 }
diff --git a/gdb/tui/tui-data.h b/gdb/tui/tui-data.h
index a25ab11..a0e296f 100644
--- a/gdb/tui/tui-data.h
+++ b/gdb/tui/tui-data.h
@@ -30,12 +30,6 @@
 struct tui_source_window_base;
 struct tui_source_window;
 
-/* This is a point definition.  */
-struct tui_point
-{
-  int x, y;
-};
-
 /* A deleter that calls delwin.  */
 struct curses_deleter
 {
@@ -114,7 +108,8 @@
   /* Window height.  */
   int height = 0;
   /* Origin of window.  */
-  struct tui_point origin = {0, 0};
+  int x = 0;
+  int y = 0;
   /* Viewport height.  */
   int viewport_height = 0;
 };
diff --git a/gdb/tui/tui-layout.c b/gdb/tui/tui-layout.c
index ba0b367..0a7812a 100644
--- a/gdb/tui/tui-layout.c
+++ b/gdb/tui/tui-layout.c
@@ -468,7 +468,7 @@
 			  int origin_x_, int origin_y_)
 {
   if (width == width_ && height == height_
-      && origin.x == origin_x_ && origin.y == origin_y_
+      && x == origin_x_ && y == origin_y_
       && handle != nullptr)
     return;
 
@@ -478,14 +478,14 @@
     viewport_height = height - 2;
   else
     viewport_height = 1;
-  origin.x = origin_x_;
-  origin.y = origin_y_;
+  x = origin_x_;
+  y = origin_y_;
 
   if (handle != nullptr)
     {
 #ifdef HAVE_WRESIZE
       wresize (handle.get (), height, width);
-      mvwin (handle.get (), origin.y, origin.x);
+      mvwin (handle.get (), y, x);
       wmove (handle.get (), 0, 0);
 #else
       handle.reset (nullptr);
diff --git a/gdb/tui/tui-win.c b/gdb/tui/tui-win.c
index b0111d7..4339b7e 100644
--- a/gdb/tui/tui-win.c
+++ b/gdb/tui/tui-win.c
@@ -593,7 +593,7 @@
 
 	  new_height = screenheight - (new_height + 1);
 	  TUI_CMD_WIN->resize (new_height, screenwidth,
-			       0, locator->origin.y + 1);
+			       0, locator->y + 1);
 	  break;
 	default:
 	  if (cur_layout == SRC_DISASSEM_COMMAND)
@@ -646,12 +646,12 @@
 			      0, first_win->height - 1);
 
 	  locator->resize (1, screenwidth,
-			   0, second_win->origin.y + new_height);
+			   0, second_win->y + new_height);
 
 	  /* Change the command window's height/width.  */
-	  new_height = screenheight - (locator->origin.y + 1);
+	  new_height = screenheight - (locator->y + 1);
 	  TUI_CMD_WIN->resize (new_height, screenwidth,
-			       0, locator->origin.y + 1);
+			       0, locator->y + 1);
 	  break;
 	}
 
@@ -1078,7 +1078,7 @@
 	      struct tui_win_info *src_win_info;
 
 	      primary_win_info->resize (new_height, width,
-					0, primary_win_info->origin.y);
+					0, primary_win_info->y);
 	      if (primary_win_info->type == CMD_WIN)
 		{
 		  win_info = *(tui_source_windows ().begin ());
@@ -1090,8 +1090,8 @@
 		  src_win_info = primary_win_info;
 		}
 	      win_info->resize (win_info->height + diff, width,
-				0, win_info->origin.y);
-	      TUI_CMD_WIN->origin.y = locator->origin.y + 1;
+				0, win_info->y);
+	      TUI_CMD_WIN->y = locator->y + 1;
 	      if ((src_win_info->type == SRC_WIN
 		   || src_win_info->type == DISASSEM_WIN))
 		{
@@ -1156,16 +1156,16 @@
 		    }
 		  first_win->resize (first_win->height + first_split_diff,
 				     width,
-				     0, first_win->origin.y);
+				     0, first_win->y);
 		  second_win->resize (second_win->height + second_split_diff,
 				      width,
 				      0, first_win->height - 1);
 		  locator->resize (1, width,
-				   0, (second_win->origin.y
+				   0, (second_win->y
 				       + second_win->height + 1));
 
 		  TUI_CMD_WIN->resize (new_height, width,
-				       0, locator->origin.y + 1);
+				       0, locator->y + 1);
 		}
 	      else
 		{
@@ -1189,7 +1189,7 @@
 		    first_win->resize (new_height, width, 0, 0);
 		  else
 		    first_win->resize (first_win->height, width, 0, 0);
-		  second_win->origin.y = first_win->height - 1;
+		  second_win->y = first_win->height - 1;
 		  if (primary_win_info == second_win)
 		    second_win->resize (new_height, width,
 					0, first_win->height - 1);
@@ -1197,14 +1197,14 @@
 		    second_win->resize (second_win->height, width,
 					0, first_win->height - 1);
 		  locator->resize (1, width,
-				   0, (second_win->origin.y
+				   0, (second_win->y
 				       + second_win->height + 1));
-		  TUI_CMD_WIN->origin.y = locator->origin.y + 1;
+		  TUI_CMD_WIN->y = locator->y + 1;
 		  if ((TUI_CMD_WIN->height + diff) < 1)
-		    TUI_CMD_WIN->resize (1, width, 0, locator->origin.y + 1);
+		    TUI_CMD_WIN->resize (1, width, 0, locator->y + 1);
 		  else
 		    TUI_CMD_WIN->resize (TUI_CMD_WIN->height + diff, width,
-					 0, locator->origin.y + 1);
+					 0, locator->y + 1);
 		}
 	      if (src1 != nullptr && src1->content.empty ())
 		src1->erase_source_content ();
diff --git a/gdb/tui/tui-wingeneral.c b/gdb/tui/tui-wingeneral.c
index b92f203..17be3e2 100644
--- a/gdb/tui/tui-wingeneral.c
+++ b/gdb/tui/tui-wingeneral.c
@@ -131,7 +131,7 @@
 void
 tui_gen_win_info::make_window ()
 {
-  handle.reset (newwin (height, width, origin.y, origin.x));
+  handle.reset (newwin (height, width, y, x));
   if (handle != NULL)
     scrollok (handle.get (), TRUE);
 }