diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 1fc603d..9ac1430 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,19 @@
 2019-12-20  Tom Tromey  <tom@tromey.com>
 
+	* tui/tui-winsource.h (struct tui_source_window_base)
+	<maybe_update>: Remove line_no and addr parameters.
+	* tui/tui-stack.c (tui_show_frame_info): Set PC on sal.  Update.
+	* tui/tui-source.h (struct tui_source_window) <maybe_update>:
+	Update.
+	* tui/tui-source.c (tui_source_window::maybe_update): Remove
+	line_no and addr parameters.
+	* tui/tui-disasm.h (struct tui_disasm_window) <maybe_update>:
+	Update.
+	* tui/tui-disasm.c (tui_disasm_window::maybe_update): Remove
+	line_no and addr parameters.
+
+2019-12-20  Tom Tromey  <tom@tromey.com>
+
 	* tui/tui-winsource.c (tui_source_window_base::set_is_exec_point_at)
 	(tui_source_window_base::update_breakpoint_info): Remove asserts.
 
diff --git a/gdb/tui/tui-disasm.c b/gdb/tui/tui-disasm.c
index 94780a5..63d581b 100644
--- a/gdb/tui/tui-disasm.c
+++ b/gdb/tui/tui-disasm.c
@@ -384,31 +384,30 @@
 }
 
 void
-tui_disasm_window::maybe_update (struct frame_info *fi, symtab_and_line sal,
-				 int line_no, CORE_ADDR addr)
+tui_disasm_window::maybe_update (struct frame_info *fi, symtab_and_line sal)
 {
   CORE_ADDR low;
 
-  if (find_pc_partial_function (get_frame_pc (fi),
-				NULL, &low, NULL) == 0)
+  struct gdbarch *frame_arch = get_frame_arch (fi);
+
+  if (find_pc_partial_function (sal.pc, NULL, &low, NULL) == 0)
     {
       /* There is no symbol available for current PC.  There is no
 	 safe way how to "disassemble backwards".  */
-      low = get_frame_pc (fi);
+      low = sal.pc;
     }
   else
-    low = tui_get_low_disassembly_address (get_frame_arch (fi),
-					   low, get_frame_pc (fi));
+    low = tui_get_low_disassembly_address (frame_arch, low, sal.pc);
 
   struct tui_line_or_address a;
 
   a.loa = LOA_ADDRESS;
   a.u.addr = low;
-  if (!addr_is_displayed (addr))
-    update_source_window (get_frame_arch (fi), sal.symtab, a);
+  if (!addr_is_displayed (sal.pc))
+    update_source_window (frame_arch, sal.symtab, a);
   else
     {
-      a.u.addr = addr;
+      a.u.addr = sal.pc;
       set_is_exec_point_at (a);
     }
 }
diff --git a/gdb/tui/tui-disasm.h b/gdb/tui/tui-disasm.h
index a4b04e4..28f87c6 100644
--- a/gdb/tui/tui-disasm.h
+++ b/gdb/tui/tui-disasm.h
@@ -44,9 +44,7 @@
 
   bool location_matches_p (struct bp_location *loc, int line_no) override;
 
-  void maybe_update (struct frame_info *fi, symtab_and_line sal,
-		     int line_no, CORE_ADDR addr)
-    override;
+  void maybe_update (struct frame_info *fi, symtab_and_line sal) override;
 
   void erase_source_content () override
   {
diff --git a/gdb/tui/tui-source.c b/gdb/tui/tui-source.c
index 6c3425f..a4d808f 100644
--- a/gdb/tui/tui-source.c
+++ b/gdb/tui/tui-source.c
@@ -209,10 +209,9 @@
 }
 
 void
-tui_source_window::maybe_update (struct frame_info *fi, symtab_and_line sal,
-				 int line_no, CORE_ADDR addr)
+tui_source_window::maybe_update (struct frame_info *fi, symtab_and_line sal)
 {
-  int start_line = (line_no - (viewport_height / 2)) + 1;
+  int start_line = (sal.line - (viewport_height / 2)) + 1;
   if (start_line <= 0)
     start_line = 1;
 
@@ -223,12 +222,11 @@
 
   l.loa = LOA_LINE;
   l.u.line_no = start_line;
-  if (!(source_already_displayed
-	&& line_is_displayed (line_no)))
+  if (!(source_already_displayed && line_is_displayed (sal.line)))
     update_source_window (get_frame_arch (fi), sal.symtab, l);
   else
     {
-      l.u.line_no = line_no;
+      l.u.line_no = sal.line;
       set_is_exec_point_at (l);
     }
 }
diff --git a/gdb/tui/tui-source.h b/gdb/tui/tui-source.h
index a2b7754..15d1429 100644
--- a/gdb/tui/tui-source.h
+++ b/gdb/tui/tui-source.h
@@ -49,9 +49,7 @@
 
   bool showing_source_p (const char *filename) const;
 
-  void maybe_update (struct frame_info *fi, symtab_and_line sal,
-		     int line_no, CORE_ADDR addr)
-    override;
+  void maybe_update (struct frame_info *fi, symtab_and_line sal) override;
 
   void erase_source_content () override
   {
diff --git a/gdb/tui/tui-stack.c b/gdb/tui/tui-stack.c
index 7803b95..4f6fe8e 100644
--- a/gdb/tui/tui-stack.c
+++ b/gdb/tui/tui-stack.c
@@ -341,9 +341,13 @@
       if (!locator_changed_p)
 	return 0;
 
+      /* find_frame_sal does not always set PC, but we want to ensure
+	 that it is available in the SAL.  */
+      sal.pc = pc;
+
       for (struct tui_source_window_base *win_info : tui_source_windows ())
 	{
-	  win_info->maybe_update (fi, sal, locator->line_no, locator->addr);
+	  win_info->maybe_update (fi, sal);
 	  win_info->update_exec_info ();
 	}
 
diff --git a/gdb/tui/tui-winsource.h b/gdb/tui/tui-winsource.h
index 8b96200..1ba967c 100644
--- a/gdb/tui/tui-winsource.h
+++ b/gdb/tui/tui-winsource.h
@@ -109,8 +109,7 @@
 
   /* Update the window to display the given location.  Does nothing if
      the location is already displayed.  */
-  virtual void maybe_update (struct frame_info *fi, symtab_and_line sal,
-			     int line_no, CORE_ADDR addr) = 0;
+  virtual void maybe_update (struct frame_info *fi, symtab_and_line sal) = 0;
 
   void update_source_window_as_is  (struct gdbarch *gdbarch,
 				    struct symtab *s,